var scrolledfind = false;

function GSinit(current) {
    var scrollargs = {};
    let $anobj;
    if (gs_get_dataset(current, 'triggertype')) {
        var triggertype = gs_get_dataset(current, 'triggertype');
    } else {
        var triggertype = 'scroll';
    }

    var anargs = GSGetBasicTween(current);
    if (gs_get_dataset(current, 'path')) {
        anargs.motionPath = {
            path: gs_get_dataset(current, 'path'),
            immediateRender: true
        }
        if (gs_get_dataset(current, 'path-align')) {
            anargs.motionPath.align = gs_get_dataset(current, 'path-align');
        }
        anargs.motionPath.alignOrigin = [];
        if (gs_get_dataset(current, 'path-alignx') !== null && gs_get_dataset(current, 'path-alignx') !== undefined) {
            anargs.motionPath.alignOrigin[0] = parseFloat(gs_get_dataset(current, 'path-alignx'));
        } else {
            anargs.motionPath.alignOrigin[0] = 0.5;
        }
        if (gs_get_dataset(current, 'path-aligny') !== null && gs_get_dataset(current, 'path-aligny') !== undefined) {
            anargs.motionPath.alignOrigin[1] = parseFloat(gs_get_dataset(current, 'path-aligny'));
        } else {
            anargs.motionPath.alignOrigin[1] = 0.5;
        }
        if (gs_get_dataset(current, 'path-start') !== null && gs_get_dataset(current, 'path-start') !== undefined) {
            anargs.motionPath.start = parseFloat(gs_get_dataset(current, 'path-start'));
        }
        if (gs_get_dataset(current, 'path-end') !== null && gs_get_dataset(current, 'path-end') !== undefined) {
            anargs.motionPath.end = parseFloat(gs_get_dataset(current, 'path-end'));
        }
        if (gs_get_dataset(current, 'path-orient')) {
            anargs.motionPath.autoRotate = true;
        }

    }
    if (gs_get_dataset(current, 'stagger')) {
        var stagerobj = gs_get_dataset(current, 'stagger');
        if (stagerobj.indexOf(".") == 0 || stagerobj.indexOf("#") == 0) {
            if (stagerobj.indexOf(".") !== 0) {
                $anobj = document.querySelectorAll(stagerobj);
            }
            if (stagerobj.indexOf("#") !== 0) {
                $anobj = document.querySelector(stagerobj);
            }
        } else {
            $anobj = document.querySelectorAll('.' + stagerobj);
        }
    } else if (gs_get_dataset(current, 'text')) {
        var $texttype = gs_get_dataset(current, 'text');

        // get id of currrent
        var splittextobj = current;
        var split = new SplitText(splittextobj, { type: $texttype });
        if ($texttype == 'chars') {
            $anobj = split.chars;
        } else if ($texttype == 'words') {
            $anobj = split.words;
        } else {
            $anobj = split.lines;
        }
    } else if (gs_get_dataset(current, 'svgdraw')) {
        let svgarray = [];
        let shapes = ['path', 'line', 'polyline', 'polygon', 'rect', 'ellipse', 'circle'];
        for (let shape in shapes) {
            const getShapes = current.querySelectorAll(shapes[shape]);
            if (getShapes.length > 0) {
                svgarray.push(getShapes);
            }
        }
        $anobj = svgarray;
        if (gs_get_dataset(current, 'from') == 'yes') {
            anargs.drawSVG = "0%";
        } else {
            anargs.drawSVG = "100%";
        }
        if (gs_get_dataset(current, 'bg')) {
            anargs.stroke = gs_get_dataset(current, 'bg');
        }

    }else if (gs_get_dataset(current, 'morphend')) {
        let morphend = gs_get_dataset(current, 'morphend');
        if(document.getElementById('editor').length == 0) {
            MorphSVGPlugin.convertToPath("circle, rect, ellipse, line, polygon, polyline");
        }

        if(gs_get_dataset(current, 'morphstart')){
            let morphstart = gs_get_dataset(current, 'morphstart');
            if (morphstart.indexOf("#") != 0) {
                morphstart = '#' + morphstart;
            }
            $anobj = morphstart;
        }else{
            
            let svgarray = [];
            let shapes = ['path'];
            for (let shape in shapes) {
                const getShapes = current.querySelectorAll(shapes[shape]);
                if (getShapes.length > 0) {
                    svgarray.push(getShapes);
                }
            }
            $anobj = svgarray;
        }

        anargs.morphSVG = {
            shape:morphend,
            origin: (gs_get_dataset(current, 'morphorigin')) ? gs_get_dataset(current, 'morphorigin') : '50% 50%',
            type: "rotational"
        }

    }else if(gs_get_dataset(current, 'stchild')){
        if(current.querySelector('.block-editor-block-list__layout') !== null){
            $anobj = current.querySelector('.block-editor-block-list__layout').children;
        }else{
            $anobj = current.children;
        }
    }
    else {
        if (gs_get_dataset(current, 'customobject')) {
            if (gs_get_dataset(current, 'customobject').indexOf("#") == 0) {
                var customobject = gs_get_dataset(current, 'customobject');
            } else {
                var customobject = '#' + gs_get_dataset(current, 'customobject');
            }
            $anobj = customobject;
        } else {
            $anobj = current;
        }
    }

    if (gs_get_dataset(current, 'stagger') || gs_get_dataset(current, 'text') || gs_get_dataset(current, 'svgdraw') || gs_get_dataset(current, 'stchild')) {
        anargs.stagger = {};
        if (gs_get_dataset(current, 'stdelay')) {
            anargs.stagger.each = gs_get_dataset(current, 'stdelay');
        } else {
            anargs.stagger.each = 0.2;
        }
        if (gs_get_dataset(current, 'strandom') == 'yes') {
            anargs.stagger.from = "random";
        }
    }
    var animation = gsap.timeline();
    if (gs_get_dataset(current, 'from') == 'yes') {
        animation.from($anobj, anargs);
    } else {
        animation.to($anobj, anargs);
    }
    if (gs_get_dataset(current, 'delay')) {
        animation.delay(parseFloat(gs_get_dataset(current, 'delay')));
    }
    if (gs_get_dataset(current, 'loop') == 'yes') {
        if (gs_get_dataset(current, 'yoyo') == 'yes') {
            animation.yoyo(true);
        }
        animation.repeat(-1);
        if (gs_get_dataset(current, 'delay') && gs_get_dataset(current, 'repeatdelay') == 'yes') {
            animation.repeatDelay(parseFloat(gs_get_dataset(current, 'delay')));
        }
    }

    var multianimations = JSON.parse(gs_get_dataset(current, 'multianimations'));
    if (multianimations) {
        for (var curr = 0; curr < multianimations.length; curr++) {
            let rx = multianimations[curr].rx;
            let ry = multianimations[curr].ry;
            let r = multianimations[curr].r;
            let px = multianimations[curr].x;
            let py = multianimations[curr].y;
            let pxo = multianimations[curr].xo;
            let pyo = multianimations[curr].yo;
            let sc = multianimations[curr].s;
            let scx = multianimations[curr].sx;
            let scy = multianimations[curr].sy;
            let width = multianimations[curr].width;
            let height = multianimations[curr].height;
            let autoAlpha = multianimations[curr].o;
            let bg = multianimations[curr].bg;
            let origin = multianimations[curr].origin;
            let de = multianimations[curr].delay;
            let ea = multianimations[curr].ease;
            let du = multianimations[curr].duration;
            let from = multianimations[curr].from;
            let customtime = multianimations[curr].time;
            let customobj = multianimations[curr].obj;
            let onhov = multianimations[curr].hover;
            let curanobj = $anobj;

            let multiargs = {};
            if (rx) multiargs.rotationX = parseFloat(rx);
            if (ry) multiargs.rotationY = parseFloat(ry);
            if (r) multiargs.rotation = parseFloat(r);
            if (px) multiargs.x = parseFloat(px);
            if (py) multiargs.y = parseFloat(py);
            if (pxo) multiargs.xPercent = parseFloat(pxo);
            if (pyo) multiargs.yPercent = parseFloat(pyo);
            if (sc) multiargs.scale = parseFloat(sc);
            if (scx) multiargs.scaleX = parseFloat(scx);
            if (scy) multiargs.scaleY = parseFloat(scy);
            if (autoAlpha) multiargs.autoAlpha = parseInt(autoAlpha) / 100;
            if (du) multiargs.duration = parseFloat(du);
            if (de) multiargs.delay = parseFloat(de);
            if (bg) multiargs.backgroundColor = bg;
            if (width) multiargs.width = width;
            if (height) multiargs.height = height;
            if (origin) multiargs.transformOrigin = origin;
            if (!customtime) customtime = ">";
            if (ea) {
                if(ea == 'none'){
                    multiargs.ease = "none";
                }else{
                    let $ease = ea.split("-");
                    multiargs.ease = $ease[0] + "." + $ease[1];
                }
            }

            if (customobj && document.querySelectorAll(customobj).length > 0) {
                $anobj = document.querySelector(customobj);
            }

            if (from == "yes") {
                if (onhov == "yes") {
                    let childanimation = gsap.timeline();
                    childanimation.from($anobj, multiargs, customtime).reverse();
                    curanobj.addEventListener("mouseenter", function (event) {
                        childanimation.play();
                    });
                    curanobj.addEventListener("mouseleave", function (event) {
                        childanimation.reverse();
                    });
                } else {
                    animation.from($anobj, multiargs, customtime);
                }

            } else {
                if (onhov == "yes") {
                    let childanimation = gsap.timeline();
                    childanimation.to($anobj, multiargs, customtime).reverse();
                    curanobj.addEventListener("mouseenter", function (event) {
                        childanimation.play();
                    });
                    curanobj.addEventListener("mouseleave", function (event) {
                        childanimation.reverse();
                    });
                } else {
                    animation.to($anobj, multiargs, customtime);
                }
            }
        }
    }
    if (triggertype == 'load') {
        if (gs_get_dataset(current, 'videoplay') == 'yes') {
            GSplayVideo($anobj);
        }
        animation.play();
    }
    else if (triggertype == 'batch') {
        scrolledfind = true;
        if (gs_get_dataset(current, 'customtrigger')) {
            var batchobj = gs_get_dataset(current, 'customtrigger');
            if (batchobj.indexOf(".") == 0) {
                var $batchobj = document.querySelector(batchobj);
            } else {
                var $batchobj = document.querySelector('.' + batchobj);
            }
        }
        GSBatchScrollTrigger(current, anargs, $batchobj);
    }
    else if (triggertype == 'hover') {
        let curanobj='';
        if (current.getAttribute('data-customtrigger')) {
            if (current.getAttribute('data-customtrigger').indexOf("#") == 0) {
                var customtrigger = current.getAttribute('data-customtrigger');
            } else {
                var customtrigger = '#' + current.getAttribute('data-customtrigger');
            }
            curanobj = document.querySelector(customtrigger);
        } else {
            curanobj = current;
        }
        animation.pause();
        animation.reverse();
        if (curanobj) {
            curanobj.addEventListener("mouseenter", function (event) {
                if (gs_get_dataset(current, 'videoplay') == 'yes') {
                    GSplayVideo($anobj);
                }
                animation.play();
            });
        }

        if (curanobj) {
            curanobj.addEventListener("mouseleave", function (event) {
                if (gs_get_dataset(current, 'videoplay') == 'yes') {
                    GSpauseVideo($anobj);
                }
                animation.reverse();
            });
        }

    }
    else if (triggertype == 'click') {
        let curanobj='';
        if (current.getAttribute('data-customtrigger')) {
            if (current.getAttribute('data-customtrigger').indexOf("#") == 0) {
                var customtrigger = current.getAttribute('data-customtrigger');
            } else {
                var customtrigger = '#' + current.getAttribute('data-customtrigger');
            }
            curanobj = document.querySelector(customtrigger);
        } else {
            curanobj = current;
        }
        animation.pause();
        animation.reverse();
        if (curanobj) {
            curanobj.addEventListener('click',
                function (event) {
                    if (gs_get_dataset(current, 'videoplay') == 'yes') {
                        GSplayVideo($anobj);
                    }
                    animation.play();
                }
            );
        }

    }
    else {
        scrolledfind = true;
        if (gs_get_dataset(current, 'customtrigger')) {
            if (gs_get_dataset(current, 'customtrigger').indexOf("#") == 0) {
                var customtrigger = gs_get_dataset(current, 'customtrigger');
            } else {
                var customtrigger = '#' + gs_get_dataset(current, 'customtrigger');
            }
        } else {
            var customtrigger = current;
        }
        scrollargs.trigger = customtrigger;

        if (gs_get_dataset(current, 'triggerstart')) {
            scrollargs.start = gs_get_dataset(current, 'triggerstart');
        } else {
            scrollargs.start = "top 92%";
        }
        if (gs_get_dataset(current, 'triggerend')) {
            scrollargs.end = gs_get_dataset(current, 'triggerend');
        }

        if (gs_get_dataset(current, 'triggerscrub')) {
            scrollargs.scrub = parseFloat(gs_get_dataset(current, 'triggerscrub'));
        }
        if (gs_get_dataset(current, 'triggersnap')) {
            scrollargs.snap = parseFloat(gs_get_dataset(current, 'triggersnap'));
        }
        if (gs_get_dataset(current, 'pinned')) {
            scrollargs.pin = true;
        }
        if (gs_get_dataset(current, 'pinspace')) {
            scrollargs.pinSpacing = false;
        }
        if (gs_get_dataset(current, 'triggeraction')) {
            scrollargs.toggleActions = gs_get_dataset(current, 'triggeraction');
        } else {
            scrollargs.toggleActions = 'play pause resume reverse';
        }
        scrollargs.animation = animation;
        if (gs_get_dataset(current, 'videoplay') == 'yes') {
            scrollargs.onToggle = self => self.isActive ? GSplayVideo($anobj) : GSpauseVideo($anobj);
        }
        scrollargs.fastScrollEnd=true;
        //scrollargs.markers = true;
        ScrollTrigger.create(scrollargs);
    }
}

document.addEventListener('DOMContentLoaded', function(event) {
    //the event occurred
  
    let gs_wrappers = document.getElementsByClassName('gs-gsap-wrap');
    if (gs_wrappers.length > 0) {
        for (let i = 0; i < gs_wrappers.length; i++) {
            let current = gs_wrappers[i];
            GSinit(current);
        };
    
        if (scrolledfind) { //Compatibility with lazy load script
            document.addEventListener('lazyloaded', function (e) {
                ScrollTrigger.refresh();
            });
        }
    }
    
    let gs_wrappersdata = document.querySelectorAll('[data-gsapinit]');
    if (gs_wrappersdata.length > 0) {
        for (let i = 0; i < gs_wrappersdata.length; i++) {
            let current = gs_wrappersdata[i];
            GSinit(current);
        };
    }
});

function gs_get_dataset(elem, attribute) {
    return elem.getAttribute('data-' + attribute);
};

function GSplayVideo(el) {
    let vid = el.find("video");
    if (vid.length && vid.find('source').length) {
        if (vid[0].paused) {
            vid[0].play();
        }
    }
}

function GSpauseVideo(el) {
    let vid = el.find("video");
    if (vid.length && vid.find('source').length) {
        if (!vid[0].paused) {
            vid[0].pause();
        }
    }
}

function GSBatchScrollTrigger(current, anargs, $batchobj) {
    var scrollargs = {};
    if (gs_get_dataset(current, 'triggerstart')) {
        scrollargs.start = gs_get_dataset(current, 'triggerstart');
    } else {
        scrollargs.start = "top 92%";
    }
    if (gs_get_dataset(current, 'triggerend')) {
        scrollargs.end = gs_get_dataset(current, 'triggerend');
    }
    var batchenter = {};
    var batchenterback = {};
    var batchleave = {};
    var batchleaveback = {};
    var batchinit = {};
    for (let batchitem in anargs) {
        if (batchitem == 'x' || batchitem == 'y' || batchitem == 'xPercent' || batchitem == 'yPercent' || batchitem == 'rotation' || batchitem == 'rotationX' || batchitem == 'rotationY') {
            batchenter[batchitem] = 0;
            batchenterback[batchitem] = 0;
            batchleave[batchitem] = -anargs[batchitem];
            batchleaveback[batchitem] = anargs[batchitem];
            batchinit[batchitem] = anargs[batchitem];
        }
        if (batchitem == 'scale' || batchitem == 'scaleX' || batchitem == 'scaleY' || batchitem == 'autoAlpha') {
            batchenter[batchitem] = 1;
            batchenterback[batchitem] = 1;
            batchleave[batchitem] = anargs[batchitem];
            batchleaveback[batchitem] = anargs[batchitem];
            batchinit[batchitem] = anargs[batchitem];
        }
        if (batchitem == 'transformOrigin' || batchitem == 'duration') {
            batchinit[batchitem] = anargs[batchitem];
        }
    }
    batchenter.overwrite = batchleave.overwrite = batchenterback.overwrite = batchleaveback.overwrite = true;

    if (gs_get_dataset(current, 'batchint')) {
        var batchstagger = parseFloat(gs_get_dataset(current, 'batchint'));
    } else {
        var batchstagger = 0.15;
    }
    batchenter.stagger = { each: batchstagger };
    batchenterback.stagger = { each: batchstagger };
    if (gs_get_dataset(current, 'batchrandom') == 'yes') {
        batchenter.stagger.from = "random";
        batchenterback.stagger.from = "random";
    }

    gsap.set($batchobj, batchinit);
    scrollargs.onEnter = batch => gsap.to(batch, batchenter);
    scrollargs.onLeave = batch => gsap.to(batch, batchleave);
    scrollargs.onEnterBack = batch => gsap.to(batch, batchenterback);
    scrollargs.onLeaveBack = batch => gsap.to(batch, batchleaveback);
    ScrollTrigger.batch($batchobj, scrollargs);
}

function GSGetBasicTween(current) {
    var anargs = {};
    let $duration = gs_get_dataset(current, 'duration');
    $duration = parseFloat($duration);
    if(!$duration) {
        $duration = 1;
    }
    anargs.duration = $duration;

    if (gs_get_dataset(current, 'x')) {
        anargs.x = parseFloat(gs_get_dataset(current, 'x'));
    }

    if (gs_get_dataset(current, 'y')) {
        anargs.y = parseFloat(gs_get_dataset(current, 'y'));
    }

    if (gs_get_dataset(current, 'xo')) {
        anargs.xPercent = parseFloat(gs_get_dataset(current, 'xo'));
    }

    if (gs_get_dataset(current, 'yo')) {
        anargs.yPercent = parseFloat(gs_get_dataset(current, 'yo'));
    }

    if (gs_get_dataset(current, 'z')) {
        anargs.z = parseFloat(gs_get_dataset(current, 'z'));
    }

    if (gs_get_dataset(current, 'width')) {
        anargs.width = gs_get_dataset(current, 'width');
    }

    if (gs_get_dataset(current, 'height')) {
        anargs.height = gs_get_dataset(current, 'height');
    }

    if (gs_get_dataset(current, 'r')) {
        anargs.rotation = parseFloat(gs_get_dataset(current, 'r'));
    }

    if (gs_get_dataset(current, 'rx')) {
        anargs.rotationX = parseFloat(gs_get_dataset(current, 'rx'));
    }

    if (gs_get_dataset(current, 'ry')) {
        anargs.rotationY = parseFloat(gs_get_dataset(current, 'ry'));
    }

    if (gs_get_dataset(current, 's')) {
        anargs.scale = parseFloat(gs_get_dataset(current, 's'));
    }

    if (gs_get_dataset(current, 'sx')) {
        anargs.scaleX = parseFloat(gs_get_dataset(current, 'sx'));
    }

    if (gs_get_dataset(current, 'sy')) {
        anargs.scaleY = parseFloat(gs_get_dataset(current, 'sy'));
    }
    if (gs_get_dataset(current, 'boxshadow')) {
        anargs.boxShadow = gs_get_dataset(current, 'boxshadow').toString();
        let colorarray = anargs.boxShadow.split('#');
        gsap.set(current, { boxShadow: "0 0 0 0 #" + colorarray[1] + "" });
    }
    if (gs_get_dataset(current, 'o')) {
        anargs.autoAlpha = parseInt(gs_get_dataset(current, 'o')) / 100;
        if (anargs.autoAlpha == 0.01) {
            anargs.autoAlpha = 0;
        }
    }
    if (gs_get_dataset(current, 'bg')) {
        anargs.backgroundColor = gs_get_dataset(current, 'bg');
    }
    if (gs_get_dataset(current, 'origin')) {
        anargs.transformOrigin = gs_get_dataset(current, 'origin');
    }
    if (gs_get_dataset(current, 'ease')) {
        if(gs_get_dataset(current, 'ease') == 'none'){
            anargs.ease = "none";
        }else{
            let $ease = gs_get_dataset(current, 'ease').split('-');
            anargs.ease = $ease[0] + '.' + $ease[1];
        }
    }
    return anargs;
}