function GSSeqinit(current) {
    var scrollargs = {};
    if (current.getAttribute('data-triggertype')) {
        var triggertype = current.getAttribute('data-triggertype');
    } else {
        var triggertype = 'scroll';
    }
    let images = JSON.parse(current.getAttribute('data-images'));

    let $anobj = current;
    gsap.set($anobj, { attr: { "data-index": 0} });
    let anargs = {};
    if (current.getAttribute('data-delay')) {
        anargs.delay = parseFloat(current.getAttribute('data-delay'));
    }
    if (current.getAttribute('data-duration')) {
        anargs.duration = parseFloat(current.getAttribute('data-duration'));
    }
    if(current.getAttribute('data-ease') == 'none'){
        anargs.ease = "none";
    }else{
        let $ease = current.getAttribute('data-ease').split('-');
        anargs.ease = $ease[0] + '.' + $ease[1];
    }
    anargs.immediateRender = true;
    anargs.attr = { 
        "data-index": images.length - 1
    }
    anargs.snap = "data-index";
    anargs.onUpdate = function () {
        let getindex = current.querySelector('img').parentNode.getAttribute('data-index');
        current.querySelector('img').setAttribute("src", images[getindex]); 
    }
    var animation = gsap.timeline();

    animation.to($anobj, anargs);


    if (triggertype == 'load') {
        animation.play();
    }
    else if (triggertype == 'hover') {
        let curanobj='';
        if (current.getAttribute('data-customtrigger')) {
            if (current.getAttribute('data-customtrigger').indexOf("#") == 0) {
                var customtrigger = current.getAttribute('data-customtrigger');
            } else {
                var customtrigger = '#' + current.getAttribute('data-customtrigger');
            }
            curanobj = document.querySelector(customtrigger);
        } else {
            curanobj = current;
        }
        animation.pause();
        animation.reverse();
        if (curanobj) {
            curanobj.addEventListener("mouseenter", function (event) {
                animation.play();
            });
        }

        if (curanobj) {
            curanobj.addEventListener("mouseleave", function (event) {
                animation.reverse();
            });
        }

    }
    else if (triggertype == 'click') {
        let curanobj='';
        if (current.getAttribute('data-customtrigger')) {
            if (current.getAttribute('data-customtrigger').indexOf("#") == 0) {
                var customtrigger = current.getAttribute('data-customtrigger');
            } else {
                var customtrigger = '#' + current.getAttribute('data-customtrigger');
            }
            curanobj = document.querySelector(customtrigger);
        } else {
            curanobj = current;
        }
        animation.pause();
        animation.reverse();
        if (curanobj) {
            curanobj.addEventListener('click',
                function (event) {
                    animation.play();
                }
            );
        }
    }
    else {
        if (current.getAttribute('data-customtrigger')) {
            if (current.getAttribute('data-customtrigger').indexOf("#") == 0) {
                var customtrigger = current.getAttribute('data-customtrigger');
            } else {
                var customtrigger = '#' + current.getAttribute('data-customtrigger');
            }
        } else {
            var customtrigger = current;
        }
        scrollargs.trigger = customtrigger;

        if (current.getAttribute('data-triggerstart')) {
            scrollargs.start = current.getAttribute('data-triggerstart');
        } else {
            scrollargs.start = "top 92%";
        }
        if (current.getAttribute('data-triggerend')) {
            scrollargs.end = current.getAttribute('data-triggerend');
            scrollargs.scrub = 1;
        }
        if (current.getAttribute('data-triggeraction')) {
            scrollargs.toggleActions = current.getAttribute('data-triggeraction');
        } else {
            scrollargs.toggleActions = 'play pause resume reverse';
        }
        
        scrollargs.animation = animation;    
        scrollargs.fastScrollEnd=true;
        //scrollargs.markers = true;
        ScrollTrigger.create(scrollargs);
    }
}

document.addEventListener('DOMContentLoaded', function(event) {
    //the event occurred
    let gs_wrappers = document.getElementsByClassName('gs-sequencer-wrap');
    if (gs_wrappers.length > 0) {
        for (let i = 0; i < gs_wrappers.length; i++) {
            let current = gs_wrappers[i];
            GSSeqinit(current);
        };
    }
});